/* 
(C) OOMusou 2011 http://oomusou.cnblogs.com

Filename    : simple_fsm_moore_2_always_2_ns_ol_ng.v
Synthesizer : Quartus II 8.1
Description : 2 always block for moore fsm (NO GOOD)
Release     : Jun.05,2011 1.0
*/

module simple_fsm (
  clk,
  rst_n,
  w_i,
  z_o
);

input  clk;
input  rst_n;
input  w_i;
output z_o;

parameter IDLE = 2'b00;
parameter S0   = 2'b01;
parameter S1   = 2'b10;

reg [1:0] curr_state;
reg [1:0] next_state;
reg z_o;

// state reg
always@(posedge clk or negedge rst_n)
  if (~rst_n) curr_state <= IDLE;
  else        curr_state <= next_state;
    
// next state logic + output logic 
always@(*)
  case (curr_state)
    IDLE    : if (w_i)   {next_state, z_o} = {S0  , 1'b0};
              else       {next_state, z_o} = {IDLE, 1'b0};
    S0      : if (w_i)   {next_state, z_o} = {S1  , 1'b0};
              else       {next_state, z_o} = {IDLE, 1'b0};
    S1      : if (w_i)   {next_state, z_o} = {S1  , 1'b1}; // always output 1'b1
              else       {next_state, z_o} = {IDLE, 1'b1}; // always output 1'b1
    default :            {next_state, z_o} = {IDLE, 1'b0};
  endcase

endmodule